/*
 * $Id$
 */

package org.codehaus.mojo.appassembler.model;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * Class Daemon.
 * 
 * @version $Revision$ $Date$
 */
public class Daemon implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field id.
     */
    private String id;

    /**
     * Field mainClass.
     */
    private String mainClass;

    /**
     * Field classpath.
     */
    private Classpath classpath;

    /**
     * Field commandLineArguments.
     */
    private java.util.List commandLineArguments;

    /**
     * Field jvmSettings.
     */
    private JvmSettings jvmSettings;

    /**
     * Field environmentSetupFileName.
     */
    private String environmentSetupFileName;

    /**
     * Field showConsoleWindow.
     */
    private boolean showConsoleWindow = true;

    /**
     * Field useTimestampInSnapshotFileName.
     */
    private boolean useTimestampInSnapshotFileName = true;

    /**
     * Field useDaemonIdAsWrapperConfName.
     */
    private boolean useDaemonIdAsWrapperConfName = false;

    /**
     * Field generatorConfigurations.
     */
    private java.util.List generatorConfigurations;

    /**
     * Field repositoryName.
     */
    private String repositoryName = "repo";

    /**
     * Field licenseHeaderFile.
     */
    private String licenseHeaderFile;

    /**
     * Field wrapperLogFile.
     */
    private String wrapperLogFile;

    /**
     * Field unixScriptTemplate.
     */
    private String unixScriptTemplate;

    /**
     * Field windowsScriptTemplate.
     */
    private String windowsScriptTemplate;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addCommandLineArgument.
     * 
     * @param string
     */
    public void addCommandLineArgument( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "Daemon.addCommandLineArguments(string) parameter must be instanceof " + String.class.getName() );
        }
        getCommandLineArguments().add( string );
    } //-- void addCommandLineArgument( String ) 

    /**
     * Method addGeneratorConfiguration.
     * 
     * @param generatorConfiguration
     */
    public void addGeneratorConfiguration( GeneratorConfiguration generatorConfiguration )
    {
        if ( !(generatorConfiguration instanceof GeneratorConfiguration) )
        {
            throw new ClassCastException( "Daemon.addGeneratorConfigurations(generatorConfiguration) parameter must be instanceof " + GeneratorConfiguration.class.getName() );
        }
        getGeneratorConfigurations().add( generatorConfiguration );
    } //-- void addGeneratorConfiguration( GeneratorConfiguration ) 

    /**
     * Get the classpath field.
     * 
     * @return Classpath
     */
    public Classpath getClasspath()
    {
        return this.classpath;
    } //-- Classpath getClasspath() 

    /**
     * Method getCommandLineArguments.
     * 
     * @return java.util.List
     */
    public java.util.List getCommandLineArguments()
    {
        if ( this.commandLineArguments == null )
        {
            this.commandLineArguments = new java.util.ArrayList();
        }
    
        return this.commandLineArguments;
    } //-- java.util.List getCommandLineArguments() 

    /**
     * Get the environmentSetupFileName field.
     * 
     * @return String
     */
    public String getEnvironmentSetupFileName()
    {
        return this.environmentSetupFileName;
    } //-- String getEnvironmentSetupFileName() 

    /**
     * Method getGeneratorConfigurations.
     * 
     * @return java.util.List
     */
    public java.util.List getGeneratorConfigurations()
    {
        if ( this.generatorConfigurations == null )
        {
            this.generatorConfigurations = new java.util.ArrayList();
        }
    
        return this.generatorConfigurations;
    } //-- java.util.List getGeneratorConfigurations() 

    /**
     * Get the id field.
     * 
     * @return String
     */
    public String getId()
    {
        return this.id;
    } //-- String getId() 

    /**
     * Get the jvmSettings field.
     * 
     * @return JvmSettings
     */
    public JvmSettings getJvmSettings()
    {
        return this.jvmSettings;
    } //-- JvmSettings getJvmSettings() 

    /**
     * Get the licenseHeaderFile field.
     * 
     * @return String
     */
    public String getLicenseHeaderFile()
    {
        return this.licenseHeaderFile;
    } //-- String getLicenseHeaderFile() 

    /**
     * Get the mainClass field.
     * 
     * @return String
     */
    public String getMainClass()
    {
        return this.mainClass;
    } //-- String getMainClass() 

    /**
     * Get the repositoryName field.
     * 
     * @return String
     */
    public String getRepositoryName()
    {
        return this.repositoryName;
    } //-- String getRepositoryName() 

    /**
     * Get the unixScriptTemplate field.
     * 
     * @return String
     */
    public String getUnixScriptTemplate()
    {
        return this.unixScriptTemplate;
    } //-- String getUnixScriptTemplate() 

    /**
     * Get the windowsScriptTemplate field.
     * 
     * @return String
     */
    public String getWindowsScriptTemplate()
    {
        return this.windowsScriptTemplate;
    } //-- String getWindowsScriptTemplate() 

    /**
     * Get the wrapperLogFile field.
     * 
     * @return String
     */
    public String getWrapperLogFile()
    {
        return this.wrapperLogFile;
    } //-- String getWrapperLogFile() 

    /**
     * Get the showConsoleWindow field.
     * 
     * @return boolean
     */
    public boolean isShowConsoleWindow()
    {
        return this.showConsoleWindow;
    } //-- boolean isShowConsoleWindow() 

    /**
     * Get the useDaemonIdAsWrapperConfName field.
     * 
     * @return boolean
     */
    public boolean isUseDaemonIdAsWrapperConfName()
    {
        return this.useDaemonIdAsWrapperConfName;
    } //-- boolean isUseDaemonIdAsWrapperConfName() 

    /**
     * Get the useTimestampInSnapshotFileName field.
     * 
     * @return boolean
     */
    public boolean isUseTimestampInSnapshotFileName()
    {
        return this.useTimestampInSnapshotFileName;
    } //-- boolean isUseTimestampInSnapshotFileName() 

    /**
     * Method removeCommandLineArgument.
     * 
     * @param string
     */
    public void removeCommandLineArgument( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "Daemon.removeCommandLineArguments(string) parameter must be instanceof " + String.class.getName() );
        }
        getCommandLineArguments().remove( string );
    } //-- void removeCommandLineArgument( String ) 

    /**
     * Method removeGeneratorConfiguration.
     * 
     * @param generatorConfiguration
     */
    public void removeGeneratorConfiguration( GeneratorConfiguration generatorConfiguration )
    {
        if ( !(generatorConfiguration instanceof GeneratorConfiguration) )
        {
            throw new ClassCastException( "Daemon.removeGeneratorConfigurations(generatorConfiguration) parameter must be instanceof " + GeneratorConfiguration.class.getName() );
        }
        getGeneratorConfigurations().remove( generatorConfiguration );
    } //-- void removeGeneratorConfiguration( GeneratorConfiguration ) 

    /**
     * Set the classpath field.
     * 
     * @param classpath
     */
    public void setClasspath( Classpath classpath )
    {
        this.classpath = classpath;
    } //-- void setClasspath( Classpath ) 

    /**
     * Set the commandLineArguments field.
     * 
     * @param commandLineArguments
     */
    public void setCommandLineArguments( java.util.List commandLineArguments )
    {
        this.commandLineArguments = commandLineArguments;
    } //-- void setCommandLineArguments( java.util.List ) 

    /**
     * Set the environmentSetupFileName field.
     * 
     * @param environmentSetupFileName
     */
    public void setEnvironmentSetupFileName( String environmentSetupFileName )
    {
        this.environmentSetupFileName = environmentSetupFileName;
    } //-- void setEnvironmentSetupFileName( String ) 

    /**
     * Set the generatorConfigurations field.
     * 
     * @param generatorConfigurations
     */
    public void setGeneratorConfigurations( java.util.List generatorConfigurations )
    {
        this.generatorConfigurations = generatorConfigurations;
    } //-- void setGeneratorConfigurations( java.util.List ) 

    /**
     * Set the id field.
     * 
     * @param id
     */
    public void setId( String id )
    {
        this.id = id;
    } //-- void setId( String ) 

    /**
     * Set the jvmSettings field.
     * 
     * @param jvmSettings
     */
    public void setJvmSettings( JvmSettings jvmSettings )
    {
        this.jvmSettings = jvmSettings;
    } //-- void setJvmSettings( JvmSettings ) 

    /**
     * Set the licenseHeaderFile field.
     * 
     * @param licenseHeaderFile
     */
    public void setLicenseHeaderFile( String licenseHeaderFile )
    {
        this.licenseHeaderFile = licenseHeaderFile;
    } //-- void setLicenseHeaderFile( String ) 

    /**
     * Set the mainClass field.
     * 
     * @param mainClass
     */
    public void setMainClass( String mainClass )
    {
        this.mainClass = mainClass;
    } //-- void setMainClass( String ) 

    /**
     * Set the repositoryName field.
     * 
     * @param repositoryName
     */
    public void setRepositoryName( String repositoryName )
    {
        this.repositoryName = repositoryName;
    } //-- void setRepositoryName( String ) 

    /**
     * Set the showConsoleWindow field.
     * 
     * @param showConsoleWindow
     */
    public void setShowConsoleWindow( boolean showConsoleWindow )
    {
        this.showConsoleWindow = showConsoleWindow;
    } //-- void setShowConsoleWindow( boolean ) 

    /**
     * Set the unixScriptTemplate field.
     * 
     * @param unixScriptTemplate
     */
    public void setUnixScriptTemplate( String unixScriptTemplate )
    {
        this.unixScriptTemplate = unixScriptTemplate;
    } //-- void setUnixScriptTemplate( String ) 

    /**
     * Set the useDaemonIdAsWrapperConfName field.
     * 
     * @param useDaemonIdAsWrapperConfName
     */
    public void setUseDaemonIdAsWrapperConfName( boolean useDaemonIdAsWrapperConfName )
    {
        this.useDaemonIdAsWrapperConfName = useDaemonIdAsWrapperConfName;
    } //-- void setUseDaemonIdAsWrapperConfName( boolean ) 

    /**
     * Set the useTimestampInSnapshotFileName field.
     * 
     * @param useTimestampInSnapshotFileName
     */
    public void setUseTimestampInSnapshotFileName( boolean useTimestampInSnapshotFileName )
    {
        this.useTimestampInSnapshotFileName = useTimestampInSnapshotFileName;
    } //-- void setUseTimestampInSnapshotFileName( boolean ) 

    /**
     * Set the windowsScriptTemplate field.
     * 
     * @param windowsScriptTemplate
     */
    public void setWindowsScriptTemplate( String windowsScriptTemplate )
    {
        this.windowsScriptTemplate = windowsScriptTemplate;
    } //-- void setWindowsScriptTemplate( String ) 

    /**
     * Set the wrapperLogFile field.
     * 
     * @param wrapperLogFile
     */
    public void setWrapperLogFile( String wrapperLogFile )
    {
        this.wrapperLogFile = wrapperLogFile;
    } //-- void setWrapperLogFile( String ) 


            public java.util.List getAllClasspathElements()
            {
                if ( classpath == null )
                {
                    return java.util.Collections.EMPTY_LIST;
                }

                java.util.List elements = new java.util.ArrayList(
                    classpath.getDependencies().size() + classpath.getDirectories().size() );
                elements.addAll( classpath.getDirectories() );
                elements.addAll( classpath.getDependencies() );
                return elements;
            }
              
    private String modelEncoding = "UTF-8";

    /**
     * Set an encoding used for reading/writing the model.
     *
     * @param modelEncoding the encoding used when reading/writing the model.
     */
    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    /**
     * @return the current encoding used when reading/writing this model.
     */
    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
